﻿/// <reference path="../../../../Resources/TypeDefinitions/jquery/jquery.d.ts"/>
/// <reference path="../../../../Resources/TypeDefinitions/jqueryui/jqueryui.d.ts"/>
/// <reference path="../../../../Resources/TypeDefinitions/knockout/knockout.d.ts"/>
/// <reference path="../../../../rubbish.ts"/>

var NpmConnectorIndexingStatusPageViewModel = (function () {
    function NpmConnectorIndexingStatusPageViewModel() {
        this.progressBarValue = ko.observable(0);
        this.startTime = ko.observable();
        this.elapsedTime = ko.observable();
        this.statusText = ko.observable();
        this.completed = ko.observable(false);
    }
    NpmConnectorIndexingStatusPageViewModel.prototype.update = function (data) {
        this.progressBarValue(data.progress);
        this.startTime(data.startTime);
        this.elapsedTime(data.elapsedTime);
        this.statusText(data.statusText);
        this.completed(data.completed);
    };
    return NpmConnectorIndexingStatusPageViewModel;
})();

function PgNpmConnectorIndexingStatusPage(input) {
    ko.bindingHandlers.progressBar = {
        init: function (element, valueAccessor, allBindings, viewModel, bindingContext) {
            $(element).progressbar({ value: ko.unwrap(valueAccessor()) });
        }, update: function (element, valueAccessor, allBindings, viewModel, bindingContext) {
            $(element).progressbar('option', { value: ko.unwrap(valueAccessor()) });
        }
    };

    var vm = new NpmConnectorIndexingStatusPageViewModel();
    ko.applyBindings(vm);

    var doUpdate = function () {
        $.ajax({
            url: input.updateUrl,
            data: { connectorId: input.connectorId },
            type: 'POST',
            success: function (data) {
                vm.update(data);
                setTimeout(doUpdate, 1000);
            }
        });
    };

    doUpdate();
}
